/*"Gear Indicator Dll": Simple OutGauge server for Directx 9 games
 * Author: Vladimir Kadlec
 *         vladimirkadlec@gmail.com
 *         http://www.fi.muni.cz/~xkadlec
 */
/*
This file is part of Gear Indicator Dll.

Gear Indicator Dll is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gear Indicator Dll is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gear Indicator Dll; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <time.h>
#include "outsim.h"
#include "rbr.h"

#define NUMBER_OF_CARS 8

typedef struct {
    char debug;
    char *ip;
    int port;
    RBRCarInfo **car_struct;
    unsigned int *car_slot;
    int out_skt;
    HANDLE proc_handle;
    HMODULE hmodule;
    float shiftl[NUMBER_OF_CARS];
    clock_t start_time;
} Config;
void print_config (Config *conf);
void init_config (Config *conf);
int read_config (char *file_name, Config *conf);

#endif
