/*"Gear Indicator Dll": Simple OutGauge server for Directx 9 games
 * Author: Vladimir Kadlec
 *         vladimirkadlec@gmail.com
 *         http://www.fi.muni.cz/~xkadlec
/*
This file is part of Gear Indicator Dll. The code is based on the
"Proxy-Dll" concept by Michael Koch, see http://www.mikoweb.eu

Gear Indicator Dll is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gear Indicator Dll is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gear Indicator Dll; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#pragma once

class myIDirect3DSwapChain9 : public IDirect3DSwapChain9
{
public:
    myIDirect3DSwapChain9(IDirect3DSwapChain9* pOriginal, IDirect3DDevice9* pDevice);
    virtual ~myIDirect3DSwapChain9(void);

    // START: The original DX9 function definitions
	HRESULT __stdcall QueryInterface (REFIID riid, void** ppvObj);
    ULONG   __stdcall AddRef(void);
    ULONG   __stdcall Release(void);
    HRESULT __stdcall Present(CONST RECT* pSourceRect,CONST RECT* pDestRect,HWND hDestWindowOverride,CONST RGNDATA* pDirtyRegion,DWORD dwFlags);
    HRESULT __stdcall GetFrontBufferData(IDirect3DSurface9* pDestSurface);
    HRESULT __stdcall GetBackBuffer(UINT iBackBuffer,D3DBACKBUFFER_TYPE Type,IDirect3DSurface9** ppBackBuffer);
    HRESULT __stdcall GetRasterStatus(D3DRASTER_STATUS* pRasterStatus);
    HRESULT __stdcall GetDisplayMode(D3DDISPLAYMODE* pMode);
    HRESULT __stdcall GetDevice(IDirect3DDevice9** ppDevice);
    HRESULT __stdcall GetPresentParameters(D3DPRESENT_PARAMETERS* pPresentationParameters);
    // END: The original DX9 function definitions

private:
    IDirect3DSwapChain9   *m_pIDirect3DSwapChain9;
	IDirect3DDevice9	  *m_pIDirect3DDevice9;

	// This is our test function
	void ShowWeAreHere(void);
};
